/* Sistemas Integrados TECNISA
   Servios

Nome: LIMPA_PEDIDO

Descrio:
Limpa os dados dos Pedidos e do Manufatura

@C:\WIN_PRJ\SQL\END_CONV\SQLSERVER\2830_PEDSTP_LIMPA_PEDIDO.SQL

Converso:
19/11/2002 - Andr Rodrigo */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'LIMPA_PEDIDO'       AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

DROP PROCEDURE LIMPA_PEDIDO
GO

CREATE PROCEDURE LIMPA_PEDIDO
    @P_CDFILLISTA VARCHAR(2000),
    @P_TCDFILIAL  VARCHAR(1),
    @P_NMOPERADOR VARCHAR(40),
    @P_DSSISTEMA  VARCHAR(3),
    @P_DSLIMPEZA  VARCHAR(500),
    @P_DTPEDIDO   DATETIME,
    @P_IDLIMPO    VARCHAR(1) OUTPUT

 AS

    DECLARE @V_IDLIMPO       VARCHAR(1);
    DECLARE @V_CONTADOR      NUMERIC;

    DECLARE @CUR_PED_CDFILIAL       VARCHAR(4);
    DECLARE @CUR_PED_NRPEDIDO       VARCHAR(10);
    DECLARE @C_CDFILIAL             VARCHAR(40);
    DECLARE @C_NRPEDIDO             VARCHAR(10);

BEGIN
   SET @V_IDLIMPO = '0';

   /* DELETA A MOVIMENTAO DE O.P. BASEADAS NOS PEDIDOS DE VENDAS */
   DECLARE CUR_PED CURSOR FOR
      SELECT CDFILIAL,NRPEDIDO
      FROM   PEDIDO
      WHERE ((CHARINDEX(@P_CDFILLISTA, CDFILIAL) <> 0) OR @P_TCDFILIAL = 'T') AND
             (CONVERT(DATETIME, CONVERT(VARCHAR, DTPEDIDO,103)) <= CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTPEDIDO,103)))

   OPEN CUR_PED;
--   FETCH NEXT FROM CUR_PED INTO @C_CDFILIAL, @C_NRPEDIDO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
         FETCH NEXT FROM CUR_PED INTO @C_CDFILIAL, @C_NRPEDIDO;   /* Teste */

      /* DELETAR OS TENS DOS PEDIDOS */
      SELECT  @V_CONTADOR = COUNT(*)
      FROM    ITEMPRODUTO
      WHERE  (CDFILIALPED = @C_CDFILIAL) AND
             (NRPEDIDO    = @C_NRPEDIDO);
      IF @V_CONTADOR > 0 BEGIN
         SET @V_IDLIMPO = '9';
      END
      ELSE BEGIN
         DELETE HISITEMPED
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);

         DELETE PEDIDOP
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);

         DELETE ITEMPEDIDO
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);

         DELETE PARPEDIDO
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);

         UPDATE PROITPROP
         SET NRPEDIDO = NULL
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);

         DELETE PEDIDO
         WHERE (CDFILIAL = @CUR_PED_CDFILIAL) AND
               (NRPEDIDO = @CUR_PED_NRPEDIDO);
      END;
   END;
   CLOSE CUR_PED;
   DEALLOCATE CUR_PED;

   IF @@ROWCOUNT <> 0 BEGIN
      INSERT INTO LOGLIMPEZA
         (DTLIMPDADOS, DSSISTLIMPEZ, NMOPERLIMPEZ,
          DTFINALIMPEZ, DSLIMPEZA)
       VALUES
          (GETDATE(), @P_DSSISTEMA, @P_NMOPERADOR,
           @P_DTPEDIDO, @P_DSLIMPEZA);
   END;

   SET @P_IDLIMPO = @V_IDLIMPO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LIMPA_PEDIDO','4.05.126';
GO

