IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'TRILHAUDIT_INSUMOANA' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER TRILHAUDIT_INSUMOANA
GO

CREATE TRIGGER TRILHAUDIT_INSUMOANA
ON INSUMOANA
FOR UPDATE,INSERT, DELETE
AS
BEGIN
   DECLARE @V_NRSEQTRILHA  NUMERIC(10);
   DECLARE @V_NMPRODUTO    VARCHAR(50);
   DECLARE @V_NMINSPECAO   VARCHAR(50);
   DECLARE @V_ITEMALTERADO VARCHAR(300);
   DECLARE @V_NEWTIPOINSU  VARCHAR(50);
   DECLARE @V_OLDTIPOINSU  VARCHAR(50);
   DECLARE @V_CDOPERADOR   VARCHAR(12);
   DECLARE @V_CLIENT_INFO  VARCHAR(64);
   DECLARE @V_TIPO         VARCHAR(1);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

   DECLARE @V_NRSEQINSUMOANA_NEW NUMERIC;
   DECLARE @V_CDPRODUTO_NEW      VARCHAR(10);
   DECLARE @V_IDPROCPROD_NEW     VARCHAR(1);
   DECLARE @V_CDINSPECAO_NEW     VARCHAR(10);
   DECLARE @V_CDPRODINSU_NEW     VARCHAR(10);
   DECLARE @V_QTDEBRUTANA_NEW    DOUBLE PRECISION;
   DECLARE @V_QTRENDANA_NEW      DOUBLE PRECISION;
   DECLARE @V_QTDELIQANA_NEW     DOUBLE PRECISION;
   DECLARE @V_CDTIPOINSU_NEW     VARCHAR(3);

   DECLARE @V_NRSEQINSUMOANA_OLD NUMERIC;
   DECLARE @V_CDPRODUTO_OLD      VARCHAR(10);
   DECLARE @V_IDPROCPROD_OLD     VARCHAR(1);
   DECLARE @V_CDINSPECAO_OLD     VARCHAR(10);
   DECLARE @V_CDPRODINSU_OLD     VARCHAR(10);
   DECLARE @V_QTDEBRUTANA_OLD    DOUBLE PRECISION;
   DECLARE @V_QTRENDANA_OLD      DOUBLE PRECISION;
   DECLARE @V_QTDELIQANA_OLD     DOUBLE PRECISION;
   DECLARE @V_CDTIPOINSU_OLD     VARCHAR(3);

   SET @V_ITEMALTERADO = '';

   DECLARE C_CURSOR_I CURSOR FOR
      SELECT
         'E' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL,
         NRSEQINSUMOANA,
         CDPRODUTO,
         IDPROCPROD,
         CDINSPECAO,
         CDPRODINSU,
         QTDEBRUTANA,
         QTRENDANA,
         QTDELIQANA,
         CDTIPOINSU
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'A' IDCOMANDO,
         INSERTED.NRSEQINSUMOANA,
         INSERTED.CDPRODUTO,
         INSERTED.IDPROCPROD,
         INSERTED.CDINSPECAO,
         INSERTED.CDPRODINSU,
         INSERTED.QTDEBRUTANA,
         INSERTED.QTRENDANA,
         INSERTED.QTDELIQANA,
         INSERTED.CDTIPOINSU,

         DELETED.NRSEQINSUMOANA,
         DELETED.CDPRODUTO,
         DELETED.IDPROCPROD,
         DELETED.CDINSPECAO,
         DELETED.CDPRODINSU,
         DELETED.QTDEBRUTANA,
         DELETED.QTRENDANA,
         DELETED.QTDELIQANA,
         DELETED.CDTIPOINSU

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRSEQINSUMOANA = DELETED.NRSEQINSUMOANA

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.NRSEQINSUMOANA,
         INSERTED.CDPRODUTO,
         INSERTED.IDPROCPROD,
         INSERTED.CDINSPECAO,
         INSERTED.CDPRODINSU,
         INSERTED.QTDEBRUTANA,
         INSERTED.QTRENDANA,
         INSERTED.QTDELIQANA,
         INSERTED.CDTIPOINSU,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
      OPEN C_CURSOR_I;

      FETCH NEXT FROM C_CURSOR_I INTO @V_TIPO, @V_NRSEQINSUMOANA_NEW, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW,
                                      @V_CDINSPECAO_NEW, @V_CDPRODINSU_NEW, @V_QTDEBRUTANA_NEW, @V_QTRENDANA_NEW,
                                      @V_QTDELIQANA_NEW, @V_CDTIPOINSU_NEW,

                                      @V_NRSEQINSUMOANA_OLD, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, @V_CDINSPECAO_OLD,
                                      @V_CDPRODINSU_OLD, @V_QTDEBRUTANA_OLD, @V_QTRENDANA_OLD,
                                      @V_QTDELIQANA_OLD, @V_CDTIPOINSU_OLD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPO = 'E') BEGIN
            SET @V_ITEMALTERADO = 'Excluso';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            SELECT @V_NMPRODUTO = NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = @V_CDPRODINSU_OLD;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'E', GETDATE(), NULL, 'Excluso de Reagente ' + @V_NMPRODUTO, @V_DSREMOTEOPER, 'Excluso de Reagente ');
         END
         ELSE IF (@V_TIPO = 'I') BEGIN
            SET @V_ITEMALTERADO = 'Insero de Reagente';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            SELECT @V_NMPRODUTO = NMPRODUTO
              FROM PRODUTO
             WHERE CDPRODUTO = @V_CDPRODINSU_NEW;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW, 'I', GETDATE(), NULL, 'Insero do Reagente' + @V_NMPRODUTO, @V_DSREMOTEOPER, @V_ITEMALTERADO);
         END
         ELSE BEGIN
            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            IF (@V_NRSEQINSUMOANA_NEW <> @V_NRSEQINSUMOANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Chave Primria Sequencial';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_NRSEQINSUMOANA_OLD, @V_NRSEQINSUMOANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDPRODUTO_NEW <> @V_CDPRODUTO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Produto';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDPRODUTO_OLD, @V_CDPRODUTO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_IDPROCPROD_NEW <> @V_IDPROCPROD_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Processo do Produto';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_IDPROCPROD_OLD, @V_IDPROCPROD_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDINSPECAO_NEW <> @V_CDINSPECAO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDINSPECAO_OLD, @V_CDINSPECAO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDINSPECAO_NEW <> @V_CDINSPECAO_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Inspeo';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDINSPECAO_OLD, @V_CDINSPECAO_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDPRODINSU_NEW <> @V_CDPRODINSU_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Alterao do Reagente';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_CDPRODINSU_OLD, @V_CDPRODINSU_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_QTDEBRUTANA_NEW <> @V_QTDEBRUTANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Alterao da Qt. Bruta do Reagente';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_QTDEBRUTANA_OLD, @V_QTDEBRUTANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_QTRENDANA_NEW <> @V_QTRENDANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Alterao do Rendimento do Reagente';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_QTRENDANA_OLD, @V_QTRENDANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_QTDELIQANA_NEW <> @V_QTDELIQANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Alterao da Qt. Lquida do Reagente';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_QTDELIQANA_OLD, @V_QTDELIQANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_CDTIPOINSU_NEW <> @V_CDTIPOINSU_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Alterao Tipo de Insumo do Reagente ';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               SELECT @V_NEWTIPOINSU = NMTIPOINSU
                 FROM TIPOINSU
                WHERE CDTIPOINSU = @V_CDTIPOINSU_NEW;

               SELECT @V_OLDTIPOINSU = NMTIPOINSU
                 FROM TIPOINSU
                WHERE CDTIPOINSU = @V_CDTIPOINSU_OLD;


               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_OLDTIPOINSU, @V_NEWTIPOINSU, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;
         END;
      FETCH NEXT FROM C_CURSOR_I INTO @V_TIPO, @V_NRSEQINSUMOANA_NEW, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW,
                                      @V_CDINSPECAO_NEW, @V_CDPRODINSU_NEW, @V_QTDEBRUTANA_NEW, @V_QTRENDANA_NEW,
                                      @V_QTDELIQANA_NEW, @V_CDTIPOINSU_NEW,

                                      @V_NRSEQINSUMOANA_OLD, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, @V_CDINSPECAO_OLD,
                                      @V_CDPRODINSU_OLD, @V_QTDEBRUTANA_OLD, @V_QTRENDANA_OLD,
                                      @V_QTDELIQANA_OLD, @V_CDTIPOINSU_OLD;
   END;
   CLOSE C_CURSOR_I;
   DEALLOCATE C_CURSOR_I;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TRILHAUDIT_INSUMOANA','6.05.xxx';
GO